;Program KZ_203RX pro 16F627 Kdov zmek
;Rev.:19.6.2003
;POPIS: odzkoueno
;Progr.: OSC-LP, WD-ON, CP-OFF, MCLR-INT, BOD-ne, PUT-ano, LVP-ne, CPD-ne
;
	       
	LIST	P=16F627
#include	"p16f628.inc"
;
ZNAK_1	  equ	0xAA	;mus souhlasit se znaky v pgm KZ_203TX
ZNAK_2    equ	0x47
ZNAK_3	  equ	0xA3
ZNAK_4    equ 	0x36      
;
BUF_0	  equ	20	;posledn znak
BUF_1	  equ	21
BUF_2	  equ	22
BUF_3	  equ	23
BUF_4     equ	24
BUF_5	  equ	25
BUF_6	  equ	26
BUF_7	  equ	27	;prvn znak
TEMP	  equ	28
FLAGS	  equ	29
CNT_BAD	  equ	30
CNT_100	  equ	31
CNT_1S	  equ	32
CNT_1M	  equ	33
CNT_10M	  equ	34
CNT_BYTE  equ	35
CNT_LOOP  equ	36
CNT_BEEP  equ	37
CNT_PWRX  equ	38
HW_FG	  equ	39
;
DATA_1	  equ	40
DATA_2	  equ	41
DATA_3	  equ	42
;
STCK_W	  equ	7E
STCK_ST	  equ	7F	
;
#define	COL_0	PORTA,0		;(init H) vst.COLUMN 0-budi ENTER
#define	COL_1	PORTA,1		;(init H) vstup COLUMN 1
#define	COL_2	PORTA,2		;(init H) vstup COLUMN 2
#define	MAGNET	PORTA,3		;(init H) vstup MAGNET
#define	LED	PORTA,4		;(init H) vstup LED
#define	PGM	PORTA,5		;vstup programovn
#define NAP_RX	PORTB,0		;(init L) vstup napjen RX
#define DATA_RX	PORTB,1		;vstup
;		PORTB,2		;TX nepouit
#define BUZZER	PORTB,3		;(init L) vstup BUZZER
#define	ENTER	7		;vstup COL_0 x ROW_3 = znak ENTER
;
;bity registru FLAGS
#define	FLG_PGM		FLAGS,0	;programovn
#define	FLG_DT		FLAGS,1	;aktivace od domovnho telefonu
#define	FLG_OK		FLAGS,2
#define	FLG_BLK		FLAGS,3	;ti nespn pokusy zablokuj na 10 min
#define	FLG_MAG		FLAGS,4	;m bt puls magnet
#define FLG_AKTIV	FLAGS,5	;aktivn vstup znak
#define FLG_RX		FLAGS,6	;int.rutina vyhodnotila pjem
#define	NAPAJENI_RX	HW_FG,0	;napjen RX je aktivn
;
	ORG	0
	GOTO	INIT
;
	ORG	4		;interrupt
INT	CLRWDT
	MOVWF	STCK_W		;push w,status
	SWAPF	STATUS,W
	MOVWF	STCK_ST
	BCF	STATUS,RP0	;bank_0
	BSF	FLG_RX		;test shody ZNAK pijat zprvy
	MOVFW	DATA_3
	XORLW	ZNAK_1
	BTFSS	STATUS,Z
	BCF	FLG_RX
	MOVFW	DATA_2
	MOVWF	DATA_3
	XORLW	ZNAK_2
	BTFSS	STATUS,Z
	BCF	FLG_RX
	MOVFW	DATA_1
	MOVWF	DATA_2
	XORLW	ZNAK_3
	BTFSS	STATUS,Z
	BCF	FLG_RX
	MOVFW	RCREG
	MOVWF	DATA_1
	XORLW	ZNAK_4
	BTFSS	STATUS,Z
	BCF	FLG_RX
	BTFSC	FLG_RX
	BSF	FLG_DT		;pi shod ozna aktivn dom.telefon
	SWAPF   STCK_ST,W       ;pop status,w
	MOVWF   STATUS
	SWAPF   STCK_W,F
	SWAPF   STCK_W,W
	RETFIE      
;-------------			
INIT	MOVLW	7
	MOVWF	CMCON		;vechny vstupy PA digital 
	MOVLW	B'11111111'	;init H
	MOVWF	PORTA		
	MOVLW	B'11110110'	;init H/L
	MOVWF	PORTB
	BSF	STATUS,RP0	;bank_1
	MOVLW	B'11100000'
	MOVWF	TRISA		;PortA direction
	MOVLW	B'11110110'	
	MOVWF	TRISB		;PortB direction
	MOVLW	B'00001110'
	MOVWF	OPTION_REG	;pull_up, prescaller 1:64 to WDT
	MOVLW	1
	MOVWF	RXSTA		;SPBRG (baudrate)
	BSF	TXSTA,BRGH	;nastaven pijmae (BRGH)
	BSF	PIE1,RCIE	;povolen INT RX
	BCF	STATUS,RP0	;bank_0
	BSF	RCSTA,SPEN	;nastaven i/o pijmae (SPEN)
	BSF	INTCON,PEIE	;povolen periferie INT
	BSF	INTCON,GIE	;povolen global INT
	CLRF	CNT_PWRX
	CLRF	FLAGS
;----------
MAIN	CLRWDT
	MOVLW	B'00000010'	;nuluje flagy krom FLG_DT
	ANDWF	FLAGS,F
	CLRF	CNT_BAD
NEW	CALL	NULUJ
KEY	CLRWDT
	INCF	CNT_PWRX,F	;ta napjen RX
	MOVLW	B'00100000'	;maska pro napjen RX
	XORWF	CNT_PWRX,W
	ANDLW	B'11100000'	;definuje Zero
	BTFSS	NAPAJENI_RX
	GOTO	OC_ZAP		
	BTFSC	STATUS,Z	;oekvej vypnut	
	GOTO	 KEY_1
RX_VYP	BCF	RCSTA,CREN	;vypne RX na 2,05 sec
	BCF	NAP_RX
	BCF	NAPAJENI_RX	;shod flag aktivn nap.
	GOTO	KEY_1
OC_ZAP	BTFSS	STATUS,Z	;oekvej zapnut
	GOTO	KEY_1
RX_ZAP	BSF	NAP_RX		;zapne RX na 300 ms
	BSF	RCSTA,CREN
	BSF	NAPAJENI_RX	;ozna flag aktivn nap.
;
KEY_1	BTFSS	PGM		;sleduji tlatko PGM
	BSF	FLG_PGM
	BTFSS	PGM
	BCF	LED		;zapne LED
;
	BCF	COL_0		;sleduji klvesy
	COMF	PORTB,W
	BSF	COL_0
	ANDLW	B'11110000'	;maska ROW
	MOVWF	TEMP
	BSF	TEMP,0
	BTFSC	TEMP,ENTER	;testuj ENTER
	GOTO	TST_KOD		;testuj vstupn kd
	BTFSS	STATUS,Z
	GOTO	SAVE		;byl znak, ulo ho
	BCF	COL_1
	COMF	PORTB,W
	BSF	COL_1
	ANDLW	B'11110000'
	MOVWF	TEMP
	BSF	TEMP,1
	BTFSS	STATUS,Z
	GOTO	SAVE		;byl znak, ulo ho
	BCF	COL_2
	COMF	PORTB,W
	BSF	COL_2
	ANDLW	B'11110000'	;maska ROW
	MOVWF	TEMP
	BSF	TEMP,2
	BTFSS	STATUS,Z
	GOTO	SAVE		;byl znak, ulo ho
;			
	GOTO	PWR_MAG		;nebyla stisknuta klvesa
;
SAVE	CALL	BEEP		;beep 70 ms
	CALL	POSUN		;znak do BUFFERu
	CALL	WAIT100
	BCF	COL_0		;ekej na uvolnn klvesnice
	BCF	COL_1
	BCF	COL_2
SAVE_0	CLRWDT
	COMF	PORTB,W
	ANDLW	B'11110000'
	BTFSS	STATUS,Z
	GOTO	SAVE_0
	BSF	COL_0		;uvolnno
	BSF	COL_1
	BSF	COL_2
	BSF	FLG_AKTIV
	GOTO	KEY
;-----------
TST_KOD CALL	EEP_RW
	BTFSS	FLG_PGM		;je-li flag PGM,
	GOTO	TST_0
	CALL	EEP_WR		;zpis BUFFERu do EEPROM
	CALL	BEEP
	GOTO	HOTOV
;
TST_0	CALL	EEP_RD		;shodnost (W=hodnota EEP)
	XORWF	INDF,W
	BTFSS	STATUS,Z
	GOTO	BAD_KOD		;kd nesouhlas
	INCF	FSR,F
	INCF	CNT_BYTE,F
	DECFSZ	CNT_LOOP,F
	GOTO	TST_0
	BSF	FLG_OK		;kd souhlas
;----------
PWR_MAG	CALL	OUTP
	BTFSC	FLG_PGM
	GOTO	KEY
	BTFSC	FLG_AKTIV
	GOTO	KEY
	GOTO	HOTOV
;-----------
BAD_KOD	INCF	CNT_BAD,F	;ta pokus o nesprvn kd
	MOVLW	3
	XORWF	CNT_BAD,W
	BTFSC	STATUS,Z
	BSF	FLG_BLK
	CALL	BEEP
	CALL	WAIT100
	CALL	BEEP
	CALL	WAIT100
	CALL	BEEP
	CALL	WAIT100
	CALL	BEEP
	BTFSS	FLG_BLK		;je-li flag blokovn, pak pauza 10 min
	GOTO	NEW
	CALL	WAIT10M
;-----------
HOTOV	MOVLW	B'00000010'
	ANDWF	FLAGS,F		;sma flagy krom FLG_DT, nvrat na potek
	BSF	LED
	GOTO	MAIN
;----------
POSUN	MOVFW	BUF_6
	MOVWF	BUF_7
	MOVFW	BUF_5
	MOVWF	BUF_6
	MOVFW	BUF_4
	MOVWF	BUF_5
	MOVFW	BUF_3
	MOVWF	BUF_4
	MOVFW	BUF_2
	MOVWF	BUF_3
	MOVFW	BUF_1
	MOVWF	BUF_2
	MOVFW	BUF_0
	MOVWF	BUF_1
	MOVFW	TEMP
	MOVWF	BUF_0
	RETURN
;-------------
EEP_RW	MOVLW	8		;provede 8x (8 byte)
	MOVWF	CNT_LOOP
	MOVLW	BUF_0		;nastav potek vst.BUFFRU
	MOVWF	FSR
	CLRF	CNT_BYTE	;nastav potek EEPROM
	RETURN
;-------------
EEP_WR	MOVFW	CNT_BYTE	
	BSF	STATUS,RP0	;bank_1
	MOVWF	EEADR		;zpis do EEPROM mem.
	BCF	STATUS,RP0	;bank_0
	MOVFW	INDF
	BSF	STATUS,RP0	;bank_1
	MOVWF	EEDATA
	CLRWDT
	BSF	EECON1,WREN
	BCF	INTCON,GIE	;povinn tvar
	MOVLW	55	
	MOVWF	EECON2
	MOVLW	0AA
	MOVWF	EECON2
	BSF	EECON1,WR
	BCF	EECON1,WREN	
	BSF	INTCON,GIE	;end povinnho tvaru
	BCF	STATUS,RP0	;bank_0
	CALL	WAIT100
	INCF	FSR,F
	INCF	CNT_BYTE,F
	DECFSZ	CNT_LOOP,F
	GOTO	EEP_WR
	RETURN
;-------------
EEP_RD	CLRWDT
	MOVFW	CNT_BYTE	;ten dat z EEPROM (CNT_BYTE)
	BSF	STATUS,RP0	;bank 1
	MOVWF	EEADR
	BSF	EECON1,RD
	MOVF	EEDATA,W
	BCF	STATUS,RP0	;bank 0
	RETURN
;------------
BEEP	MOVLW	.51		;beep 70ms
BEEP4M	MOVWF	CNT_BEEP
	BCF	INTCON,GIE
BEEP_1	BSF	BUZZER
	NOP
	CLRWDT
	NOP
	NOP
	BCF	BUZZER
	NOP
	DECFSZ	CNT_BEEP,F
	GOTO	BEEP_1
	BSF	INTCON,GIE
	RETURN
;-------------
OUTP	BTFSC	FLG_DT		;zapne magnet je-li FLG_OK nebo FLG_DT
	BSF	FLG_MAG
	BTFSC	FLG_OK
	BSF	FLG_MAG
	BTFSS	FLG_MAG
	RETURN			;vchod pi nezapnut magnetu
;
	CLRF	CNT_PWRX	;vypnut napjen RX
	BCF	NAP_RX
	BCF	MAGNET		;zapne magnet
	MOVLW	B'00000010'	;nuluje flagy krom FLG_DT
	ANDWF	FLAGS,F
	CLRW			;pauza 420 ms
	CALL	BEEP4M
	CALL	WAIT100
	BSF	MAGNET		;vypne magnet
	BTFSS	FLG_DT
	RETURN	
	BCF	FLG_DT
	CALL	WAIT1S		;pauza 5s jestli byl povel od dom.telefonu
	CALL	WAIT1S
	CALL	WAIT1S
	CALL	WAIT1S
	CALL	WAIT1S
	RETURN
;-----------
NULUJ	CLRF	BUF_0		;nuluje vstupn BUFFER (8 byte)
	CLRF	BUF_1
	CLRF	BUF_2
	CLRF	BUF_3
	CLRF	BUF_4
	CLRF	BUF_5
	CLRF	BUF_6
	CLRF	BUF_7
	RETURN
;-------------
WAIT100	MOVLW	.217		;100 ms
	MOVWF	TMR0
	BCF	INTCON,2
W_0	CLRWDT
	BTFSS	INTCON,2	;pznak peteen timeru
	GOTO	W_0
	BCF	INTCON,2
W_01	CLRWDT
	BTFSS	INTCON,2
	GOTO	W_01
	BCF	INTCON,2
W_02	CLRWDT
	BTFSS	INTCON,2
	GOTO	W_02
	BCF	INTCON,2
W_03	CLRWDT
	BTFSS	INTCON,2
	GOTO	W_03
	RETURN
;-------------
WAIT1S	MOVLW	.10		;1 sec
	MOVWF	CNT_1S
W_1	CALL	WAIT100
	DECFSZ	CNT_1S,F
	GOTO	W_1
	RETURN
;-------------
WAIT1M	MOVLW	.60		;1 min
	MOVWF	CNT_1M
W_2	CALL	WAIT1S
	DECFSZ	CNT_1M,F
	GOTO	W_2
	RETURN
;-------------
WAIT10M	MOVLW	.10		;10 min
	MOVWF	CNT_10M
	CALL	WAIT1M
W_3	DECFSZ	CNT_10M,F
	GOTO	W_3
	RETURN
;================
	END
